package edu.kutztown.demo.servlets;

import java.io.IOException;
import java.util.Properties;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import sun.misc.BASE64Decoder;

/**
 * Servlet implementation class Login
 */
public class Login extends HttpServlet
{
	private static final long serialVersionUID = 1L;
	private Properties p;

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException
	{
		try
		{
			String auth = request.getHeader("Authorization").substring(6)
					.trim();
			String decoded = new String(new BASE64Decoder().decodeBuffer(auth));

			int inx = decoded.indexOf(":");
			String user = decoded.substring(0, inx);
			String pass = decoded.substring(inx + 1);

			if (p.get(user).equals(pass))
			{
				// if they pass, create a session and forward to index page
				request.getSession(true);
				request.getRequestDispatcher("/index.jsp").forward(request,
						response);
			}
			else
			{
				throw new Exception();
			}
		}
		catch (Exception e)
		{
			response.setStatus(HttpServletResponse.SC_UNAUTHORIZED);
			response.setHeader("WWW-Authenticate",
					"BASIC realm=\"priveleged-few\"");
		}
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException
	{
		doGet(request, response);
	}

	public void init(ServletConfig config) throws ServletException
	{
		try
		{
			p = new Properties();
			p.load(config.getServletContext().getResourceAsStream(
					config.getInitParameter("prop")));
		}
		catch (Exception e)
		{
			throw new ServletException(e);
		}
	}

}
